commit ce80f2c0e7a86e555201e9e61a26306adff4a074
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Fri Dec 10 22:41:24 2021

    Fortran: fix checking of elemental functions of type CLASS
    
    gcc/fortran/ChangeLog:
    
            PR fortran/103606
            * resolve.c (resolve_fl_procedure): Do not access CLASS components
            before class container has been built.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/103606
            * gfortran.dg/pr103606.f90: New test.
    
    (cherry picked from commit 7e913caad081ea85da4f257265f2d3383cdbe8d5)

diff --git a/gcc/fortran/resolve.c b/gcc/fortran/resolve.c
index bf7902742e2..1367d58a963 100644
--- a/gcc/fortran/resolve.c
+++ b/gcc/fortran/resolve.c
@@ -13237,7 +13237,8 @@ resolve_fl_procedure (gfc_symbol *sym, int mp_flag)
 
   /* An elemental function is required to return a scalar 12.7.1  */
   if (sym->attr.elemental && sym->attr.function
-      && (sym->as || (sym->ts.type == BT_CLASS && CLASS_DATA (sym)->as)))
+      && (sym->as || (sym->ts.type == BT_CLASS && sym->attr.class_ok
+		      && CLASS_DATA (sym)->as)))
     {
       gfc_error ("ELEMENTAL function %qs at %L must have a scalar "
 		 "result", sym->name, &sym->declared_at);
diff --git a/gcc/testsuite/gfortran.dg/pr103606.f90 b/gcc/testsuite/gfortran.dg/pr103606.f90
new file mode 100644
index 00000000000..43283184e89
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr103606.f90
@@ -0,0 +1,12 @@
+! { dg-do compile }
+! PR fortran/103606 -  ICE in resolve_fl_procedure
+! Contributed by G.Steinmetz
+
+program p
+  type t
+  end type
+contains
+  elemental function f() result(z) ! { dg-error "CLASS variable" }
+    class(t) :: z
+  end
+end

